$(lib_binaries) += base

# ---------------------------------------------------------------------------
# gcc-base

ifneq (,$(filter $(distrelease),oneiric precise wheezy sid))
  additional_links =
else ifneq (,$(filter $(distrelease),))
  additional_links =
else
  additional_links =
endif


# do_gcc_base d_base p_base
define do_gcc_base
	dh_testdir
	dh_testroot
	rm -rf $(1)
	dh_installdirs -p$(2) \
		$(gcc_lexec_dir)

	ln -sf $(BASE_VERSION) \
	    $(1)/$(subst /$(BASE_VERSION),/$(GCC_VERSION),$(gcc_lib_dir))
	for link in $(additional_links); do \
	  ln -sf $(BASE_VERSION) \
	    $(1)/$$(dirname $(gcc_lib_dir))/$$link; \
        done

	$(if $(filter $(gcc_lib_dir),$(gcc_lexec_dir)),,
		ln -sf $(BASE_VERSION) \
			$(1)/$(subst /$(BASE_VERSION),/$(GCC_VERSION),$(gcc_lexec_dir))
		for link in $(additional_links); do \
		  ln -sf $(BASE_VERSION) \
			$(1)/$$(dirname $(gcc_lexec_dir))/$$link; \
		    done
	)

	$(if $(filter yes,$(with_spu)),
		mkdir -p $(d_base)/$(gcc_spu_lexec_dir)
		mkdir -p $(d_base)/$(gcc_spu_lib_dir)
		ln -sf $(BASE_VERSION) $(1)/$(spulibexecdir)/gcc/spu/$(GCC_VERSION)
		ln -sf $(BASE_VERSION) $(1)/usr/spu/lib/gcc/spu/$(GCC_VERSION)
	)

	dh_installdocs -p$(2) debian/README.Debian.$(DEB_TARGET_ARCH)
	rm -f $(d_base)/usr/share/doc/$(2)/README.Debian
	dh_installchangelogs -p$(2)
	dh_compress -p$(2)
	dh_fixperms -p$(2)

	$(if $(filter yes,$(3)),
		$(cross_gencontrol) dh_gencontrol -p$(2) -- -v$(DEB_VERSION) $(common_substvars)
	,
		dh_gencontrol -p$(2) -- -v$(DEB_VERSION) $(common_substvars)
	)

	dh_installdeb -p$(2)
	dh_md5sums -p$(2)
	dh_builddeb -p$(2)
endef


$(binary_stamp)-base:
ifeq ($(with_gccbase),yes)
	$(call do_gcc_base,$(d_base),$(p_base),yes)
endif
ifeq ($(with_gccxbase),yes)
	$(call do_gcc_base,$(d_xbase),$(p_xbase))
endif
	touch $@

